/*****************************************************************************
 

 thk 1/11/2012 converting to 4D Color module
 thk added Sound and Joystick
 thk 3/7/2012 added keybdint and get key  keyboard clk and data pins already changed 1/29/12
 thk 3/10/2012 had to change PSDATA to RD8 from RB5 (RB5 analog and not +5V tolerant) -works
 thk 11/26/2012 added UART3 (really UART 1) from xbee communication
 * added get Radio readable, radio read radio write and flushq
 * thk 1/7/2013 added wifi display loop and row col for display
 *****************************************************************************/
#include "MainDemo.h"
//#include "S1D13517.h"
#include "PS2KBD.h"
#include "adc.h"
#include "UART3.h"  //this is the radio UART


// Configuration bits
    #pragma config FPLLODIV = DIV_1, FPLLMUL = MUL_18, FPLLIDIV = DIV_2, FWDTEN = OFF, FCKSM = CSECME, FPBDIV = DIV_2
    #pragma config OSCIOFNC = ON, POSCMOD = XT, FSOSCEN = ON, FNOSC = PRIPLL
    #pragma config CP = OFF, BWP = OFF, PWP = OFF

///////////////////////////////// FONTS ///////////////////////////////////////
extern const FONT_FLASH     Font25;
extern const FONT_FLASH     Font35;
extern const FONT_FLASH Arial_Narrow;


/////////////////////////////// PICTURES //////////////////////////////////////
extern const BITMAP_FLASH   flower16bit;
extern const BITMAP_FLASH   flower8bit;
extern const BITMAP_FLASH   flower4bit;
extern const BITMAP_FLASH   flower1bit;
extern const BITMAP_FLASH	CLOWN1;
extern const BITMAP_FLASH   Kibacorp;
extern const BITMAP_FLASH alien1;
extern const BITMAP_FLASH coffee;
extern const BITMAP_FLASH robot;
extern const BITMAP_FLASH wheelrobot1;
extern BITMAP_FLASH Captureannouncement2;
extern BITMAP_FLASH Captureannouncement;

extern int raw_BOT1; //BOT pin1 analog
extern int raw_BOT2; //BOT pin 2 analog
 volatile char rxchar3 =0;
volatile unsigned char rxflag3 =0;
int adcvalue =0;
unsigned char status =0;
//***************new display managerfor wifi
#define ROW_MAX 15
#define COL_MAX 20
int row =0;
int col=0;
//unsigned char c;

#define WAIT_UNTIL_FINISH(x)    while(!x)
#define MIN(x,y)                ((x > y)? y: x)
    /* */
#define BTN_S1 PORTBbits.RB15
#define BTN_S2 PORTDbits.RD5
#define BTN_S3 PORTDbits.RD7
#define BTN_S4 PORTDbits.RD6
#define LED1   LATBbits.LATB12
#define LED2   LATBbits.LATB11
#define ID_SLD1 69
#define ID_1_BTN 68 //D1
#define ID_2_BTN 67 //D2
#define ID_3_BTN 66 //G
#define ID_4_BTN 65 //R
#define ID_5_BTN 64 //GB
#define ID_6_BTN 63 //RB
#define ID_MTR 99
#define ID_1_CHBOX 50
#define ID_2_CHBOX 51
#define ID_3_CHBOX 52
#define ID_4_CHBOX 53
#define ID_5_CHBOX 54
#define ID_MYEDITBOX    101
#define LISTBOX_ID 10
#define ID_STATICTEXT1 33
	EDITBOX *pEb;		//declare edit box pointer
	BUTTON *pBtn;		// declare button pointer
	SLIDER *pSlider;	//declare  slider pointer
	LISTBOX *pLb;		//declare list box pointer
	CHECKBOX *pCb;      //declare check box pointer
	STATICTEXT *pSt;    // declare static text pointer

	METER  *pMeter;     //declare meter pointer
 GOL_SCHEME *pSchemeSLD, *pSchemeBTN,*pSchemeEb, *pSchemeLb ,*pSchemeCb, *pSchemeSt,*pSchemeMTR;
 GOL_MSG msg;
 OBJ_HEADER* pFocusedObj;
 #define BUF_SIZE 100  //also defined in xbee for xbee read
 volatile unsigned char s[BUF_SIZE];
 volatile unsigned char qin = 0;  //index for queue in
volatile unsigned char qout = 0; //index for queuse out
volatile char rxchar =0;
volatile unsigned char rxflag =0;
 unsigned char previousKey1State;
 unsigned char previousKey2State;
 unsigned char c;
 unsigned char param2;
 unsigned char myc;
 unsigned char myparam2;
 int tempy=0;
void simulate(void);
int dstate =0;
XCHAR ebtext[] ={'T','h','o','m','a','s'};
XCHAR * pText =ebtext;
void CreateSchemes(void);			// Set up style schemes
void CreateWIDGETS1(void);			//create widgets

unsigned char keybdMsg(GOL_MSG* msg);				//sample keyboard to build message
unsigned char buttonMsg(GOL_MSG* msg);				//sample button to build message
void refresh (void); //refresh button screen
void configure4Dinterface(void); //must be called be Graphint
//new WIFI handlers*****************************
void next_POS (void) {
    int t ;

    if (c== 0x0d)
    {
                row++;
            if (row==ROW_MAX) {
                 row =0;
                 col =0;
                 //wait on CR for next screen
                 redLEDON();
                 c= 0;
                 while  (c !=0x0d) { //pause and wait on CR
                     t =0;
             while (t!=1) {
		  t = getcKBD();  //process key display and sent to radio
		}
                 }

             redLEDOFF();
                 SetColor(GRAY0);
                      ClearDevice();

                
            }
                return;
    }
    if (c ==0x0A) { col =0; return; }
    col++;
    if (col ==COL_MAX) {
        col =0;
        row++;
     if (row==ROW_MAX) {
                 row =0;
                 col =0;
                  redLEDON();
                  c=0;
                 while  (c !=0x0d) { //pause and wait on CR
                     t =0;
		while (t!=1) {
		  t = getcKBD();  //process key display and sent to radio

		}
                 }
                                                
             redLEDOFF();
                 SetColor(GRAY0);
                      ClearDevice();
                
            }
                return;
    }
}
void display_key (unsigned char c) {
  // ClearDevice();
	  SetColor(RED);
	  // SetFont4D (0);
	   DrawTextChar (c,col,row);
           next_POS();

}

void display_radio (unsigned char c) {
    //ClearDevice();
	  SetColor(BLACK);
	 //  SetFont4D 01);
	   DrawTextChar (c,col,row);
           next_POS();
}

void flushQueue( void) {
	qin =0;
	qout=0;

}
int radio_GetReadable( void ) {
	 //int count =0;
	 if (qin==qout) return 0;
	 if (qin>qout) return (qin-qout);
	 if (qout>qin) return (qout-qin);
	 qin =0;
	 qout =0;
	 return 0;

	}
unsigned char radio_Read(void )
 {
	 unsigned char temp =0;
	 rxflag =0;
	 temp = s[qout];
	 qout++;
	 if (qout> BUF_SIZE) qout =0;

   return temp;
 }
void __ISR(_UART_1B_VECTOR, ipl1) UART1BHandler(void)
{
	rxchar = U1BRXREG;
	s[qin]=rxchar;
	qin++;
	if (qin==BUF_SIZE)
	{
		qin =0;
	}
 	IFS2bits.U1BRXIF =0;
 	rxflag =1;

}
//this UART3A interrupt captures Easy VR input
void __ISR(_UART_3A_VECTOR, ipl1) UART3AHandler(void)
{
rxchar3 = U3ARXREG;	
 IFS1bits.U3ARXIF =0;
 rxflag3 =1;	
	
	
}

   
    int main(void)
    
    {
	     SetFont((void *) &Arial_Narrow);
	 
	    	DDPCON=0x00;
	    		AD1PCFG = 0xFFFFFFFF;
	    		
	//************************************************************
//initialize LEDs and Switches
//setup L1 and L2
	mPORTBClearBits(  BIT_12 | BIT_11 );
	mPORTBSetPinsDigitalOut( BIT_12 | BIT_11 );
//setup S1 RB15/CN12	
	mPORTBSetPinsDigitalIn( BIT_15 );
//setup S2 RD5/CN14 RD6/CN15, RD7/Cn16
mPORTDSetPinsDigitalIn( BIT_5 | BIT_6| BIT_7 );	
	/* enable pullups on change notice pins 12,14 */
ConfigCNPullups(CN14_PULLUP_ENABLE | CN12_PULLUP_ENABLE |CN15_PULLUP_ENABLE |CN16_PULLUP_ENABLE );
char buf[50];
   	GOL_MSG msg;        			// GOL message structure to interact with GOL
   	pFocusedObj =NULL;
   	
   	previousKey1State =BTN_S1 ;
   	previousKey2State =BTN_S2; 
   	unsigned char flagswitch=0;
 	
   // SHORT       width, height;
   // SHORT       counter;
    
//    const SHORT polyPoints[] = {
//        (GetMaxX()+1)/2,    (GetMaxY()+1)/4,
//        (GetMaxX()+1)*3/4,  (GetMaxY()+1)/2,
//        (GetMaxX()+1)/2,    (GetMaxY()+1)*3/4,
//        (GetMaxX()+1)/4,    (GetMaxY()+1)/2,
//        (GetMaxX()+1)/2,    (GetMaxY()+1)/4,
//    };
          flushQueue();
     configure4Dinterface();
      //configure UART1B interrupt with a priority of 1
    IEC2bits.U1BRXIE =1;
    IFS2bits.U1BRXIF =0;
    IPC12bits.U1BIP =1;

    INTEnableSystemMultiVectoredInt();
    initU3();	//initializes UART1B
 
 	resetRadio(); //reset Radio --can only be called after UART1B init
    //SYSTEMConfigPerformance(GetSystemClock());
  redLEDOFF();
 greenLEDOFF();

    /////////////////////////////////////////////////////////////////////////////
    #if defined(__dsPIC33FJ128GP804__) || defined(__PIC24HJ128GP504__)
    AD1PCFGL = 0xffff;
    #endif
    
   initADC( BOT1);
    InitGraph();
     GOLInit();      			// Initialize graphics library and create default style scheme for GOL
    
    	GOLFree();					// Clear GOL Heap
	CreateSchemes();			// Set up style schemes
	 SetFont((void *) &Arial_Narrow);
	  CreateWIDGETS1();
initKBD();  //initialize key board operation
  	//create widgets button and slider
    //  redBLOFF();
    //  greenBLON(0xffff);
   //   redLEDOFF();
   //   greenLEDOFF();
//	sprintf( buf, "+++" ); // enter command mode

 //   radio_Write(  (char*)buf, strlen(buf) );
SetColor(GRAY0);
	  ClearDevice();
            SetColor(WHITE);
	 // char dmsg [] = {'J','O','L','L','Y',0x00};
            PutImage(0, 0, (void *) &Captureannouncement2, 1);
            SetColor(BLUE);
               SetFont4D(0); //font 5x7
           char dmsg [] = " An Introduction ";
           char dmsg1 [] = " Using the PIC32";
           char dmsg2 [] = " Experimenter!";
	// char dmsg [] = "Welcome to 32   bit Exp WIFI!";
	 DrawString (0, 10, 1, &dmsg[0]);
         DrawString (0, 12, 1, &dmsg1[0]);
          DrawString (0, 14, 1, &dmsg2[0]);
//	 SetColor(RED);
//	 	 char dmsg1 [] = "Who are you?";
//	  DrawString (2, 6, 2, &dmsg1[0]);
	  	DelayMs(2000);
          
//	  SetColor(GRAY0);
//	  ClearDevice();
//	  SetColor(RED);
//	  DrawGraphicsChar ('T',5, 5, 10,10);
//	    	DelayMs(2000);
//	  SetColor(GRAY0);
//	  ClearDevice();
//	  SetColor(GREEN);
//	   SetFont4D (1);
//	   DrawTextChar ('T',4,4);
//	  DrawTextChar ('K',5,4);
//	DelayMs(2000);
SetColor(GRAY0);
	  ClearDevice();
	//****************set initial componetns states

 //***************************************************************
SHORT newVal =0;
	//n frequency hz 100-20000
//d duration in mill seconds
redLEDOFF();
greenLEDOFF();
// SetFontOrientation(0);
//
// SetFont((void *) &Font35);
// SetColor(RED);
//OutTextXY(10,10, "Sound ");
//OutTextXY(10,30, "Test ");
// Sound (1, 1000);
// Sound (2, 1000);
// Sound (3, 1000);
// Sound (4, 1000);
// Sound (5, 1000);
// Sound (6, 1000);
// Sound (7, 1000);
// redLEDOFF();
// greenLEDOFF();
// Nop();
//  SetFontOrientation(0);
//
//       SetFont((void *) &Font35);
       // 	OutTextXY(10,85, "The fastest way");
     //  int i=0;
//        SetColor(WHITE);
//	ClearDevice();
// for (i=0;i<5; i++) {
//	  SetColor(RED);
//	  OutTextXY(10,10, "Switch ");
//	OutTextXY(10,30, "test ");
//	 status =Joystick(0x0f); //wait for any buttons to be pressed and released
//	 if (status ==0) 	OutTextXY(10,60, "No button ");
//	 if (status ==1) 	OutTextXY(10,60, "UP ");
//	 if (status ==2) 	OutTextXY(10,60, "LEFT");
//	 if (status ==3) 	OutTextXY(10,60, "DOWN");
//	 if (status ==4) 	OutTextXY(10,60, "RIGHT");
//	 if (status ==5) 	OutTextXY(10,60, "FIRE");
//
//	 Sound (6, 1000);
//	// SetColor(WHITE);
//	//	ClearDevice();
// }
// add wifi handler *****************************************************
        int number =0;
        int t=0;
         SetColor(GRAY0);
         ClearDevice();
         row =0;
         col =0;
	   SetFont4D(0); //font 5x7
            flushQueue();
           resetRadio();
           DelayMs(2000);
                
           while (1) {  //main radio loop
                greenLEDON();
		t = getcKBD();  //process key display and sent to radio
		if (t ==1) {
		 greenLEDOFF();
              //   display_key(c);   //show on display as key dataipconfig

		   putU3( c);  //output acharacter at a time to radio
		}
                //process radio
               // redLEDOFF();
             number=   radio_GetReadable();
          
             while (number !=0){
             c=  radio_Read();
               display_radio(c);   //show on display as radio data
             number=   radio_GetReadable();
            //  redLEDON();
                          }
             redLEDOFF();

           }
//**********************************************************************

//read keyboard and output char while t is just character
 
 	SetColor(RED);
	OutTextXY(10,10, "Keyboard ");
	OutTextXY(10,30, "Test ");
	OutTextXY(10,60," ");
	 int t1 =0;
	 int j=0;
	 do {
		 greenLEDON();
		t1 = getcKBD();
		if (t1 ==1) {
		 greenLEDOFF();
		 Sound (6, 1000);
		OutChar( (XCHAR) c);
		j++;
		  
		}
		}while (j<5);  
 		greenLEDOFF();
	SetColor(WHITE);	
	ClearDevice();
	
while(1) {	
int i;
 redLEDOFF();
 	DelayMs(2000);
		GOLDraw();
		redLEDON();
		DelayMs(2000);
		
	adcvalue=	readADC(BOT1);
	//adcvalue = adcvalue>>2;
	tempy =0;
	for (i=0; i<adcvalue; i++)
	{
		tempy= tempy+3;
	}
		tempy =tempy/100;
		if (tempy> 30) tempy =30;
		newVal =tempy;
 			pMeter =(METER*)GOLFindObject(ID_MTR);
 			  SetState(pMeter,MTR_DRAW_UPDATE );
 			 MtrSetVal( pMeter,newVal);
 		//	 Sound (7, 1000);
		  	
		
}		
while(1) {
		DelayMs(100);
		flagswitch =0;
		flagswitch = buttonMsg(&msg);
	
  if (flagswitch ==1)				//sample keyboard to build message
{
	GOLMsg(&msg);
	GOLDraw();
				// if keyboard activity then message
}	
} //end of while loop		
	
	
   } //make this end of main



/*********************************************************************
* Function: WORD GOLMsgCallback(WORD objMsg, OBJ_HEADER* pObj, 
*								GOL_MSG* pMsg)
*
* Overview: This function must be implemented by user. GOLMsg() 
*			function calls it each time the valid message for 
*			the object received
*
* Input: objMsg - translated message for the object,
*        pObj - pointer to the object,
*        pMsg - pointer to the non-translated, raw GOL message 
*
* Output: if the function returns non-zero the draw control 
*		  will be passed to GOL
*
********************************************************************/
 	//	redBLOFF(); redBLON();
   //    redLEDON(); redLEDOFF();
   //  greenLEDON(); greenLEDOFF();
   // 	mPORTBClearBits(  BIT_12 | BIT_11 );  11 is d2  12 is D1
   // 
WORD GOLMsgCallback(WORD objMsg, OBJ_HEADER* pObj, GOL_MSG* pMsg) 
{


//if (GetObjID(pObj) == ID_1_CHBOX)
//{
//	 ClearDevice();
//	 //	pCb =(CHECKBOX*)GOLFindObject(ID_1_CHBOX);
//if(objMsg == CB_MSG_CHECKED)
//{
//
//	pCb =(CHECKBOX*)GOLFindObject(ID_1_CHBOX);
//		  	SetState(pCb,CB_DRAW | CB_CHECKED);
//		  	mPORTBSetBits( BIT_12 );
//		  		
//}
//else if(objMsg == CB_MSG_UNCHECKED)
//{
////BtnSetText(pObj,Released); // set text for released state
//		pCb =(CHECKBOX*)GOLFindObject(ID_1_CHBOX);
//		ClrState(pCb, CB_CHECKED);
//		    SetState(pCb,CB_DRAW);
//		  	mPORTBClearBits ( BIT_12 );
//		  	pCb =(CHECKBOX*)GOLFindObject(ID_2_CHBOX);
//		 		SetState(pCb,CB_DRAW );
//}
//
//}
//
//	
//
//if (GetObjID(pObj) == ID_2_CHBOX)
//
//{
//	 ClearDevice();
//	 
//if(objMsg == CB_MSG_CHECKED)
//{
////BtnSetText(pObj,Pressed); // set text for pressed state
//	pCb =(CHECKBOX*)GOLFindObject(ID_2_CHBOX);
//		  	SetState(pCb,CB_DRAW | CB_CHECKED);
//		  	mPORTBSetBits( BIT_11 );
//}		  
//else if(objMsg == CB_MSG_UNCHECKED)
//{
////BtnSetText(pObj,Released); // set text for released state
//		pCb =(CHECKBOX*)GOLFindObject(ID_2_CHBOX);
//		ClrState(pCb, CB_CHECKED);
//		    SetState(pCb,CB_DRAW);
//		  	mPORTBClearBits ( BIT_11 );
//		  
//}
//	
//}
//if (GetObjID(pObj) == ID_3_CHBOX)
//
//{
//	 ClearDevice();
//	 
//if(objMsg == CB_MSG_CHECKED)
//{
////BtnSetText(pObj,Pressed); // set text for pressed state
//	pCb =(CHECKBOX*)GOLFindObject(ID_3_CHBOX);
//		  	SetState(pCb,CB_DRAW | CB_CHECKED);
//		  redLEDON(); 
//		 
//}		  
//else if(objMsg == CB_MSG_UNCHECKED)
//{
////BtnSetText(pObj,Released); // set text for released state
//		pCb =(CHECKBOX*)GOLFindObject(ID_3_CHBOX);
//		ClrState(pCb, CB_CHECKED);
//		    SetState(pCb,CB_DRAW);
//		  		  redLEDOFF();
//}
//}
//if (GetObjID(pObj) == ID_4_CHBOX)
//
//{
//	 ClearDevice();
//	 
//if(objMsg == CB_MSG_CHECKED)
//{
////BtnSetText(pObj,Pressed); // set text for pressed state
//	pCb =(CHECKBOX*)GOLFindObject(ID_4_CHBOX);
//		  	SetState(pCb,CB_DRAW | CB_CHECKED);
//		  //redLEDON();
//		   greenLEDON(); 
//}		  
//else if(objMsg == CB_MSG_UNCHECKED)
//{
////BtnSetText(pObj,Released); // set text for released state
//		pCb =(CHECKBOX*)GOLFindObject(ID_4_CHBOX);
//		ClrState(pCb, CB_CHECKED);
//		    SetState(pCb,CB_DRAW);
//		  		 // redLEDOFF();
//		  		  greenLEDOFF();
//}	
//}
//
//	refresh();
		return 1;	
}	

/*********************************************************************
* Function: WORD GOLDrawCallback()
*
* Overview: This function must be implemented by user. GOLDraw() 
*			function calls it each time when GOL objects drawing is 
*			completed. User drawing should be done here. GOL will 
*			not change color, line type and clipping region settings 
*			while this function returns zero.
*
* Output: if the function returns non-zero the draw control 
*		  will be passed to GOL
*
********************************************************************/
WORD GOLDrawCallback()
{

	

	return 1;	
}	


void CreateSchemes(void)			// Set up style schemes
{

//    pSchemeSLD = GOLCreateScheme();
//	pSchemeBTN = GOLCreateScheme();
//	pSchemeEb = GOLCreateScheme();
//	pSchemeLb =GOLCreateScheme();
//	pSchemeCb =GOLCreateScheme();
//	pSchemeSt=GOLCreateScheme();
//	pSchemeMTR =GOLCreateScheme();
//	//Color Slider scheme*****
//	pSchemeSLD->EmbossDkColor=BLACK;
//	pSchemeSLD-> EmbossLtColor=GRAY1;
//	pSchemeSLD-> Color0=BLUE;
//
//
//	pSchemeCb-> Color0 =WHITE;
////	pSchemeCb->Color1 =BLACK;
//	pSchemeCb->TextColor0 =BLACK;
////	pSchemeCb->TextColor1 =WHITE;
//	pSchemeCb->CommonBkColor=WHITE;
//	pSchemeCb->EmbossLtColor= BLACK;
//	pSchemeCb->EmbossDkColor= BLACK;
//	pSchemeCb->pFont = (void *) &Arial_Narrow;
//
//	pSchemeBTN-> Color0 =BRIGHTRED;
//	pSchemeBTN->Color1 =LIGHTBLUE;
//	pSchemeBTN->TextColor0 =WHITE;
//	pSchemeBTN->TextColor1 =BLACK;
//	pSchemeBTN->CommonBkColor=WHITE;
//	pSchemeBTN->EmbossLtColor= GRAY1;
//	pSchemeBTN->EmbossDkColor= BLACK;
//	pSchemeBTN->pFont = (void *) &Arial_Narrow;
//
////	pSchemeBTN-> Color0 =WHITE;
////	pSchemeBTN->Color1 =BLACK;
////	pSchemeBTN->TextColor0 =BLACK;
////	pSchemeBTN->TextColor1 =WHITE;
////	pSchemeBTN->CommonBkColor=WHITE;
////	pSchemeBTN->EmbossLtColor= BLACK;
////	pSchemeBTN->EmbossDkColor= BLACK;
////	pSchemeBTN->pFont = (void *) &Arial_Narrow;
//
//	pSchemeSt-> Color0 =WHITE;
//	pSchemeSt->Color1 =BLACK;
//	pSchemeSt->TextColor0 =BLACK;
//	pSchemeSt->TextColor1 =WHITE;
//	pSchemeSt->CommonBkColor=WHITE;
//
//	pSchemeSt->pFont = (void *) &Arial_Narrow;
//
//	pSchemeEb-> Color0 =WHITE;
//	//pSchemeEb->Color1 =BLACK;
//	pSchemeEb->ColorDisabled =BLACK;
//	pSchemeEb->TextColor0 =BLACK;
////	pSchemeEb->TextColor1 =WHITE;
//	pSchemeEb->TextColorDisabled =WHITE;
//	pSchemeEb->CommonBkColor=WHITE;
//	pSchemeEb->EmbossLtColor= BLACK;
//	pSchemeEb->EmbossDkColor= BLACK;
//	 pSchemeEb->pFont = (void *) &Arial_Narrow;
//	pSchemeLb-> Color0 =WHITE;
//	pSchemeLb->Color1 =BLACK;
//	pSchemeLb->TextColor0 =BLACK;
//	pSchemeLb->TextColor1 =WHITE;
//
//	pSchemeLb->EmbossLtColor= BLACK;
//	pSchemeLb->EmbossDkColor= BLACK;
////	pSchemeLb -> pFont = (BYTE*) Font25;
//	 pSchemeLb->pFont = (void *) &Arial_Narrow;
//
//	pSchemeMTR-> Color0 =WHITE;
//	pSchemeMTR->Color1 =BLACK;
//	pSchemeMTR->TextColor0 =BLACK;
////	pSchemeMTR-> Color0 =BLACK;
////	pSchemeMTR->Color1 =WHITE;
////	pSchemeMTR->TextColor0 =WHITE;
//
//	pSchemeMTR->CommonBkColor=WHITE;
//	pSchemeMTR->EmbossLtColor= BRIGHTBLUE;
//	pSchemeMTR->EmbossDkColor= BLUE;
//
//	 pSchemeMTR->pFont = (void *) &Arial_Narrow;
	
}	
void CreateWIDGETS1(void) 
{
	
 
 pMeter= MtrCreate(
            ID_MTR,               // assign ID
           
            10, 0,110,63 , 
            MTR_DRAW |MTR_RING,      // draw object after creation
            1,                      // set initial value
            0,30,                 // set minimum and maximum value
            (void*)&Arial_Narrow,  // set title font
            (void*)&Arial_Narrow,   // set value font
            "METER",                // Text Label
           	 pSchemeMTR);          // style scheme   

//	MtrSetScaleColors(pMeter, arc1, arc2, arc3, arc4, arc5, arc6)
MtrSetScaleColors(pMeter,BRIGHTGREEN,BRIGHTGREEN,YELLOW,YELLOW,BRIGHTRED,BRIGHTRED);	
//MtrSetScaleColors(pMeter,WHITE,WHITE,WHITE,WHITE,WHITE,WHITE);


 BtnCreate(      ID_1_BTN,                // ID
                    10,74,40,94,8,   // dimension and radius
                    BTN_DRAW,       // will be dislayed after creation
                  NULL,  //pageInformation.buttonBitmapTopLeft, // bitmap
                  "Set",//  pageInformation.buttonTextTopLeft,   // text
                    pSchemeBTN );                     // Default scheme
     
    BtnCreate(      ID_2_BTN,                // ID
                    80,74,110,94,8,   // dimension and radius
                    BTN_DRAW,       // will be dislayed after creation
                  NULL,  //pageInformation.buttonBitmapTopLeft, // bitmap
                  "Clr",//  pageInformation.buttonTextTopLeft,   // text
                    pSchemeBTN );                     // Default scheme
 SldCreate(  ID_SLD1,		//slider ID
  					5,98,125,120,	//object dimensions
  					SLD_DRAW,		//set state
  					100,			//range
  					5,		//page
  					32,			//	initial position
  					pSchemeSLD 
  					);     
	//pMeter->radius =1;
       
//	CbCreate(ID_1_CHBOX,          // ID
//                   0,0,20,20,        // dimension
//                   CB_DRAW,               // Draw the object
//                   "D1",               // text
//                   pSchemeCb);              // use this scheme
//
// 	CbCreate(ID_2_CHBOX,          // ID
//                   40,0,60,20,        // dimension
//                   CB_DRAW,               // Draw the object
//                   "D2",               // text
//                   pSchemeCb);              // use this scheme
//
// 	CbCreate(ID_3_CHBOX,          // ID
//                   0,22,20,42,        // dimension
//                   CB_DRAW,               // Draw the object
//                   "R",               // text
//                   pSchemeCb);              // use this scheme
//	CbCreate(ID_4_CHBOX,          // ID
//                   40,22,60,42,        // dimension
//                   CB_DRAW,               // Draw the object
//                   "G",               // text
//                   pSchemeCb);              // use this scheme
//
//    StCreate(ID_STATICTEXT1,          // ID
//             0,44,90,62,           // dimension
//            ST_DRAW | ST_FRAME | ST_CENTER_ALIGN ,                   // has frame and center aligned
//             "Checkbox demo", // text
//            	pSchemeSt);                // use given scheme
//
   
 
   

	
}

unsigned char buttonMsg(GOL_MSG* msg)				//sample keyboard to build message
{
	 previousKey1State= BTN_S1;
  previousKey2State = BTN_S2;
//  if( GOLGetFocus() ==NULL) { take out focus
//	   
//	  
//  pFocusedObj =(OBJ_HEADER *)GOLFindObject(ID_1_CHBOX);
// 	 GOLSetFocus (pFocusedObj);
//  }

	if (BTN_S1==0)  //button is depressed 
	{
//		 DelayMs(100);
//			if (BTN_S1!=0) return (0);
//	msg->type    = TYPE_KEYBOARD;
////	msg->param1 = GetObjID(GOLGetFocus());
//msg->param1 = ID_1_CHBOX;
//	 msg->param2 =SCAN_CR_PRESSED;
//	msg->uiEvent =  EVENT_KEYSCAN;
	//	refresh();
	return (1);
	
	}

	else	if (BTN_S2==0)  {
	 DelayMs(100); 
			if (BTN_S2!=0) return (0);
			
//	 pFocusedObj = GOLGetFocusNext();
//	GOLSetFocus(pFocusedObj);
////	refresh();
//	msg->type    = TYPE_KEYBOARD;
////	msg->param1 = GetObjID(GOLGetFocus());
//msg->param1 = ID_2_CHBOX;
//	 msg->param2 =SCAN_CR_PRESSED;
//	msg->uiEvent =  EVENT_KEYSCAN;
	return (1);	
	}	
	else	if (BTN_S3==0)  {
	 DelayMs(100); 
			if (BTN_S3!=0) return (0);
			
//	 pFocusedObj = GOLGetFocusNext();
//	GOLSetFocus(pFocusedObj);
////	refresh();
//	msg->type    = TYPE_KEYBOARD;
//	msg->param1 = GetObjID(GOLGetFocus());
//msg->param1 = ID_3_CHBOX;
//	 msg->param2 =SCAN_CR_PRESSED;
//	msg->uiEvent =  EVENT_KEYSCAN;
	return (1);	
	}	
	else	if (BTN_S4==0)  {
	 DelayMs(100); 
			if (BTN_S4!=0) return (0);
			
//	 pFocusedObj = GOLGetFocusNext();
//	GOLSetFocus(pFocusedObj);
////	refresh();
//	msg->type    = TYPE_KEYBOARD;
//	msg->param1 = GetObjID(GOLGetFocus());
//msg->param1 = ID_4_CHBOX;
//	 msg->param2 =SCAN_CR_PRESSED;
//	msg->uiEvent =  EVENT_KEYSCAN;
	return (1);	
	}	
	return (0);
	
}	
unsigned char keybdMsg(GOL_MSG* msg)				//sample keyboard to build message
{
//	msg->type    = TYPE_KEYBOARD;
//                    msg->uiEvent = EVENT_KEYSCAN;           
//                    msg->param1  = ID_SLD1;			
//                    msg->param2  = SCAN_UP_PRESSED;
	int t =0;
	t = getcKBD();
	if (t==0) return 0;
//msg->type    = TYPE_KEYBOARD;
	
  //msg->param1= ID_UP_BTN;
//		msg->param1 = GetObjID(GOLGetFocus());
//	if (t ==2) {
//	 msg->param2 =param2;
//	msg->uiEvent =  EVENT_KEYSCAN;
	return (1);
}
//if ( (c=='.')) //change focus if keyboard outputs a '.'
//{
//	pFocusedObj = GOLGetFocusNext();
//	
//		//msg->param1 = GetObjID(GOLGetFocus());
//	GOLSetFocus(pFocusedObj);
// 	//msg->uiEvent =EVENT_CHARCODE;	
//	//msg->param2 = c;
//	 refresh();
//
//return(0); //unsure but cause a GOL message callback
//}
//	if ( t==1) {
//	msg->uiEvent = EVENT_CHARCODE;
// msg->param2= c;
// if (c=='.') {
//	 pFocusedObj = GOLGetFocusNext();
//	GOLSetFocus(pFocusedObj);
//
//	// refresh();
//
//
//	}
//	return (1);
	
//}
	
//	return (0);
	
//}
void refresh (void){
			pCb =(CHECKBOX*)GOLFindObject(ID_1_CHBOX); //CHECKBOX 1 D1
		    SetState(pCb,CB_DRAW );
		    pCb =(CHECKBOX*)GOLFindObject(ID_2_CHBOX);// CHECKBOX 2 D2
		  SetState(pCb,CB_DRAW);	
		    pCb =(CHECKBOX*)GOLFindObject(ID_3_CHBOX); // Green LED
		  SetState(pCb,CB_DRAW);
		    pCb =(CHECKBOX*)GOLFindObject(ID_4_CHBOX); // Green LED
		  SetState(pCb,CB_DRAW);	
		    pSt =(STATICTEXT*)GOLFindObject(ID_STATICTEXT1); // Red LED
		  SetState(pSt,ST_DRAW );	
//		    pBtn =(BUTTON*)GOLFindObject(ID_5_BTN); // Red Backlight
//		  SetState(pBtn,BTN_DRAW);	
	
	
	
	
	
}
void configure4Dinterface(void) {
	
	// initialize interrupt for 4D
    IEC1bits.U3ARXIE =1;
    IFS1bits.U3ARXIF =0;
    IPC8bits.U3AIP =1;
    ///////////////////////////////////////////////
	///   Initial I/O 4D/////////////////////////////////////////////////////////////////////
    //Step 1 make sure TX line is high so as not to confuse display
	mPORTFOpenDrainOpen(BIT_2); //RF2 open drain and tied to +2V
	mPORTFSetBits (BIT_2);  //turn RF2 high for TX of UART3A as required
	mPORTFSetPinsDigitalOut( BIT_2 );
	//mPORTEOpenDrainOpen(BIT_2); //RB3 open drain and tied to reset of 4D color
//	mPORTESetBits (BIT_2);  //turn RE2 high for reset
//	mPORTESetPinsDigitalOut( BIT_2 );
mPORTEOpenDrainOpen(BIT_5); //RE5 open drain and tied to reset of 4D color
	mPORTEClearBits (BIT_5);  //turn RE5 high for reset
	mPORTESetPinsDigitalOut( BIT_5 );
	////////////////////////////////////////////////////////////////////////
	mPORTDSetPinsDigitalOut ( BIT_10 | BIT_4); //red/green led

	
	
	
}			
void simulate(void) {

		    
}	        
	        
	        

