#ifndef __UARTDRV_H__
#define __UARTDRV_H__ 
//modified for robot UART1B 9/25/2011

#define FCY     72000000L
#define FPB     36000000L
#include <plib.h>


void resetRadio(void); //reset xbee
// initialize the UART1B serial port
int radio_Write( char *buffer, int count );
void initU3( void);
// send a character to the UART1B serial port

int putU3( int c);

// wait for a new character to arrive to the UART1B serial port
char getU3( void);
// send a null terminated string to the UART1B serial port
//examples
//puts( "Exploring the PIC32!");
//    sprintf( s, "Exploring the PIC32! %d", 17);

int puts( const char *s);

// useful macros
#define clrscr() puts( "\x1b[2J") 
#define home()   puts( "\x1b[1,1H")
#endif








