#ifndef __ADCDRV_H__
#define __ADCDRV_H__ 

//these are AD1CHS settings
#define RIR  	0x00040000 // AN4Right IR
#define LIR 	0x00050000 // AN5 Left IR
#define VBAT 	0x00080000 // AN8 Battery power
#define BOT1 	0x00090000 // AN9 left photocell
#define BOT2 	0x000A0000 // AN10 Right photocell



int readADC( int ANpin);   //parameter I/O expansion pin number this function does conversion
void initADC( int ANpin);	//initialize ADC operation ofr this I/O pin
void ADCoff(void);


#endif








